## ros-melodic-cloudwatch-metrics-common 1.1.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(cloudwatch_metrics_common)
set(CLOUDWATCH_METRICS_COMMON_VERSION 1.1.0)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()
# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

# Enable strict compiler flags if possible.
include(CheckCXXCompilerFlag)
# Removed -Wmissing-declarations until gmock is ignored
set(FLAGS -pedantic -Wno-long-long -Wall -Wextra -Wcast-qual -Wformat -Wwrite-strings -Wcast-align -Wno-error=cast-align)
foreach(FLAG ${FLAGS})
  check_cxx_compiler_flag(${FLAG} R${FLAG})
  if(${R${FLAG}})
    set(WARNING_CXX_FLAGS "${WARNING_CXX_FLAGS} ${FLAG}")
  endif()
endforeach()

if(NOT DEFINED CXX_DISABLE_WERROR)
  set(WARNING_CXX_FLAGS "-Werror ${WARNING_CXX_FLAGS}")
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${WARNING_CXX_FLAGS}")

find_package(dataflow_lite REQUIRED)
find_package(file_management REQUIRED)
find_package(aws_common REQUIRED)

if(AWSSDK_FOUND)
  set(SERVICE monitoring)
  AWSSDK_DETERMINE_LIBS_TO_LINK(SERVICE OUTPUT)
  link_directories("${AWSSDK_LIB_DIR}")
endif()

set(ALL_SRC_FILES
      src/utils/cloudwatch_metrics_facade.cpp
      src/metric_batcher.cpp
      src/metric_publisher.cpp
      src/metric_service_factory.cpp
      src/utils/metric_file_manager.cpp
      src/utils/metric_serialization.cpp
      )

add_library(${PROJECT_NAME} ${ALL_SRC_FILES})
target_link_libraries(${PROJECT_NAME}
        ${OUTPUT}
        ${file_management_LIBRARIES}
        ${dataflow_lite_LIBRARIES} )

target_include_directories(${PROJECT_NAME} PRIVATE
        ${aws_common_INCLUDE_DIRS}
        ${AWSSDK_INCLUDE_DIR}
        ${file_management_INCLUDE_DIRS}
        ${dataflow_lite_INCLUDE_DIRS} )

target_include_directories(${PROJECT_NAME} PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

#############
## Install ##
#############

# Mark executables and/or libraries for installation
install(TARGETS ${PROJECT_NAME}
  EXPORT "${PROJECT_NAME}-targets"
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

## Mark cpp header files for installation
install(
  DIRECTORY include/
  DESTINATION include/
)

export(TARGETS ${PROJECT_NAME}
  FILE "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-targets.cmake")
export(PACKAGE ${PROJECT_NAME})

CONFIGURE_FILE(${PROJECT_NAME}Config.cmake.in
        ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake @ONLY)
CONFIGURE_FILE(${PROJECT_NAME}ConfigVersion.cmake.in
        ${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake @ONLY)

INSTALL(FILES ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake DESTINATION share/${PROJECT_NAME}/cmake)
INSTALL(FILES ${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake DESTINATION share/${PROJECT_NAME}/cmake)
INSTALL(EXPORT ${PROJECT_NAME}-targets DESTINATION share/${PROJECT_NAME}/cmake)


#############
## Testing ##
#############

enable_testing()
find_common_test_packages()
if(GMOCK_LIBRARY)

  macro(link_test_target target_name)
    if(TARGET ${target_name})
      target_include_directories("${target_name}" PRIVATE ${HEADERS_FOR_TESTS})
      target_link_libraries("${target_name}" ${LIBS_FOR_TESTS})
    endif()
  endmacro()

  add_common_gtest(test_cloudwatch_metrics
          test/main_test.cpp
          test/metric_publisher_test.cpp
          test/metric_serialization_test.cpp
          )

  add_common_gtest(test_pipelines
          test/metric_pipeline_test.cpp
          )
  set(LIBS_FOR_TESTS
          ${GTEST_LIBRARIES}
          pthread
          ${GMOCK_LIBRARY}
          ${PROJECT_NAME}
          )

  set(HEADERS_FOR_TESTS
          PRIVATE include
          PRIVATE ${aws_common_INCLUDE_DIRS}
          PUBLIC ${PROJECT_SOURCE_DIR}/test/include
          )

  link_test_target(test_cloudwatch_metrics)
  link_test_target(test_pipelines)

endif()

=== debian/changelog ===
ros-melodic-cloudwatch-metrics-common (1.1.5-1stretch) stretch; urgency=high

  No changes.

 -- AWS RoboMaker <ros-contributions@amazon.com>  Wed, 14 Oct 2020 07:00:00 -0000

ros-melodic-cloudwatch-metrics-common (1.1.4-1stretch) stretch; urgency=high

  * Allow user to automatically delete CloudWatch logs in batch that are > 14 days old (#56 <https://github.com/aws-robotics/cloudwatch-common/issues/56>)
    * move docstring and don't break loop
    * call fileUploadComplete
    * modify struct and add tests
    * add tests and change 2 week wording to old
    * Add lock to discard stale data container
    * extend stale data protection
    * remove setter
    * Reduce lock_guard scope
  * Bumping version to match bloom release (#51 <https://github.com/aws-robotics/cloudwatch-common/issues/51>)
    Bumping version to 1.1.3
  * Fix linting issues found by clang-tidy 6.0 (#50 <https://github.com/aws-robotics/cloudwatch-common/issues/50>)
    * clang-tidy fixes
    * revert explicit constructor declarations to maintain API compatbility
    * clang-tidy linting issues fixed manually
    * fix unit tests build break
  * Add support for Cloudwatch MetricDatum StatisticSet (#48 <https://github.com/aws-robotics/cloudwatch-common/issues/48>)
    * add support for cloudwatch metrics' StatisticSet
    * add test for metricObjectToDatum()
    * address PR comments
    * take into consideration that MetricDatum's Value and StatisticValues are mutually exclusive
    * add docstring to MetricObject constructors
  * Increase package version numbers to 1.1.2 (#44 <https://github.com/aws-robotics/cloudwatch-common/issues/44>)
  * Contributors: Jesse Ikawa, Miaofei Mei, Nick Burek, Ragha Prasad

 -- AWS RoboMaker <ros-contributions@amazon.com>  Thu, 17 Sep 2020 07:00:00 -0000

ros-melodic-cloudwatch-metrics-common (1.1.1-1stretch) stretch; urgency=high

  * Disable error on cast-align warning to support ARMhf builds (#41 <https://github.com/aws-robotics/cloudwatch-common/issues/41>)
    * Remove -Wcast-align flag to support ARMhf builds
    *  - bumped versions to 1.1.1
    - restored cast-align, but added as a warning
    - removed unused headers
    * Removed duplicate Werror
  * modify changelist to be compatible with catkin_generate_changelog (#39 <https://github.com/aws-robotics/cloudwatch-common/issues/39>)
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
  * Merge pull request #36 <https://github.com/aws-robotics/cloudwatch-common/issues/36> from aws-robotics/guard_test_libs
    Added guards for test libraries
  * Added guards for test libraries
  * Offline logs feature (#34 <https://github.com/aws-robotics/cloudwatch-common/issues/34>)
    * Add file manager and upload complete callback
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Fixed merge conflict
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add file manager test
    Still deciding if the write should just go in the FileManagerStrategy.
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add FileManager to log manager factory
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add generic file upload logic
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add reading, discovery and rotation to FileManagerStrategy
    - Add function getFileToRead that returns the best file to start reading
    from when sending data from the file to CloudWatch.
    - Add function discoverStoredFiles which finds all files in the
    storage directory and keeps them, in case there were offline logs still
    hanging around from a previous run.
    - Add rotateActiveFile which creates a new file to write to. This is
    used when we want to read from the current active file, or when the file
    size limit has been reached.
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add file management system.
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Link file management with publisher
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add test for file management system
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add reading and writing to FileManagerStrategy
    - This way the file manager strategy can handle all the core file data
    stuff, keeping track of the size of the active file and rotating it when
    neccessary.
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * cleanup
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Don't initialize file_manager_strategy yet
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add file upload statistics
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Move file management files to isolated package
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Moved tests to file_manager folder
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Update offline test location
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add comments to file management interfaces
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add more comments to file uploading
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add futures/promises to file upload tasks
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add blocking and observed queue interface
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add comments to observed_queue.h
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Make batch size configurable for file upload manager
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add subscribe method to file upload manager
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Move queues and status monitor to dataflow folder
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Atomatize status monitor
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
    * Add working dataflow pipeline
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>


=== debian/control ===
Source: ros-melodic-cloudwatch-metrics-common
Section: misc
Priority: optional
Maintainer: AWS RoboMaker <ros-contributions@amazon.com>
Build-Depends: debhelper (>= 9.0.0), cmake, google-mock, libgtest-dev, ros-melodic-aws-common, ros-melodic-catkin, ros-melodic-dataflow-lite, ros-melodic-file-management
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-cloudwatch-metrics-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-aws-common, ros-melodic-dataflow-lite, ros-melodic-file-management
Description: Library used by ROS1/2 node to publish metrics
